/*
Expects Accel_Bean to be on the bean
NEED TO HAVE BEAN CONNECTED AND VIRTUAL SERIAL ENABLED!
add Symlink if necessary:
SUDO ln -s /tmp/tty.LightBlue-Bean /dev/tty.LightBlue-Bean
to verify:
ls /dev/tty.*

READS ACCELEROMETER DATA FROM LIGHTBLUE BEAN AND WRITE IT TO A TEXT FILE

Bruno Silva Pontes

Does sending data as bytes make it a lot faster?
Can we do it 57600 baud rate? yes.
Fix initial max to not miss first song


Will start to add music commands
*/


import processing.serial.*;      //serial interface to comunicate with BlueBean


 int timeMs = 0;                  // used to time data rate
 int startTimeMs = 0;             // used to time duration of exercise
 int elapsedTimeMs = 0;
int testeEntrou = 0;
int lf = 10;                      // linefeed in ASCII
String myString = null;           //var to hold serial data
int sensors[];                    // array to read the accel values
int max[] = {30,30,30};           //experiment with constants
int maxSensors[] = {30,30,30};  
int minSensors[] = {-30,-30,-30}; // experiment with constants
float runningAvgSensors[] = {0.0, 0.0, 0.0};
//int xValue;                    // var to hold hold serial data from Bean
Serial myPort;                   // the serial port
int writeX = 10;                 // used to write values on the window
int writeY = 40;                 // used to write values on the window
int contGestos = 1;
//int flagMedicao = -1; // -1 eh soh pra inicializar. 1 eh inicio das medicoes. 2 eh medicao do meio. 3 eh fim das medicoes de um gesto.
PrintWriter output;               //to write to log file


void setup() {
  size(500,500);
  background(0);
  // list all the available serial ports
  println(Serial.list());
  // the bean is the 5th port so I open Serial.list()[4].
  // open whatever port is the one you're using.
  myPort = new Serial(this, Serial.list()[1], 57600); // can this be 57600? YES. has to match blue_bean sketch
  myPort.clear();
  // throw out the first reading, in case we started reading 
  // in the middle of a string from the sender.
  myString = myPort.readStringUntil(lf);
  myString = null; 

  textSize(12); // set size of font
  
  
  // open file to write
  output = createWriter("dataset1300millis-tapa-p-baixo.csv"); 
  output.println("X,Y,Z");  
}

void draw() {
  while (myPort.available() > 0) {
    myString = myPort.readStringUntil(lf);
    
  /*  if(testeEntrou < 10){
      println("entrou no draw");
      testeEntrou = testeEntrou + 1;
    }*/
    
    
    if (myString != null) {
        //println(myString); // Escreve no console do Processing
        myString = trim(myString);
      //sensors = int(split(myString, ','));
      //timeMs = millis();
      //elapsedTimeMs = timeMs - startTimeMs;
      //finished(elapsedTimeMs);
      //output.println(str(elapsedTimeMs) + "," + myString); // write string to file, should have flag to start
        if(myString.equals("Inicio-Medicoes-Gesto")){
            output.println("Inicio gesto " + str(contGestos));
        }
        else if(myString.equals("Fim-Medicoes-Gesto")){
            output.println("Fim gesto " + str(contGestos));
            contGestos++;
        }
        else if(myString.equals("*** COMECE O GESTO ***")){
            println(myString + " " + str(contGestos));
        }
        else if(myString.equals("*** FIM DO GESTO ***")){
            println("fim");
        }
        else{
            output.println(myString);
        }
       
      /*for (int sensorNum = 0; sensorNum < sensors.length; sensorNum++) {
 
        if (sensorNum > 2) break; // strange bug causes exception
    
        
     } */ // for sensorNum
    }  // if myString
  }    // while port
}